library stream_binder_web;

import "dart:html";
import "dart:async";
import "stream_binder.dart";

void websocketMessageTransform(MessageEvent e, EventSink<String> s) {
  s.add(e.data);
}

StreamTransformer<MessageEvent, String> createWebSocketTransformer(WebSocket ws) {
  return new StreamTransformer<MessageEvent, String>.fromHandlers(handleData: websocketMessageTransform);
}

Future<Binder> fromWebSocket(String url){
  Completer c = new Completer();
  var ws = new WebSocket(url);
  ws.onOpen.listen((_){
    var binder = new Binder(ws.onMessage.transform(createWebSocketTransformer(ws)), ws.send);
    c.complete(binder);
  });
  return c.future;
}